=== modified file 'Makefile'
--- Makefile	2007-10-29 16:19:30 +0000
+++ Makefile	2006-12-24 06:43:14 +0000
@@ -7,6 +7,3 @@
 clean:
 	rm -rf dist/
 
-check:
-	# XXX MichaelHudson 2007-10-29 bug=158361: We can't run the loggerhead
-	# tests in PQM yet :(

=== modified file 'dev.cfg'
--- dev.cfg	2007-12-12 08:36:51 +0000
+++ dev.cfg	2007-01-14 05:40:40 +0000
@@ -36,10 +36,6 @@
 server.environment="production"
 #autoreload.package="loggerhead"
 
-# We do *not* want our query arguments turned into unicode strings (as
-# we use them for revision/file ids, and these must not be unicode).
-decoding_filter.on = False
-
 # session_filter.on = True
 
 # Set to True if you'd like to abort execution if a controller gets an

=== modified file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2007-09-04 04:36:24 +0000
+++ loggerhead/branchview.py	2007-08-23 15:03:26 +0000
@@ -159,7 +159,6 @@
             h.check_rebuild()
     
     def url(self, elements, **kw):
-        "build an url relative to this branch"
         if not isinstance(elements, list):
             elements = [elements]
         if elements[0].startswith('/'):
@@ -167,10 +166,6 @@
         elements = [urllib.quote(x) for x in elements]
         return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
 
-    def context_url(self, elements, **kw):
-        "build an url relative to this branch, bringing along browsing context"
-        return self.url(elements, **util.get_context(**kw))
-    
     def last_updated(self):
         h = self.get_history()
         change = h.get_changes([ h.last_revid ])[0]

=== modified file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2007-09-04 04:36:24 +0000
+++ loggerhead/controllers/bundle_ui.py	2007-08-23 12:18:18 +0000
@@ -54,7 +54,7 @@
                 self.log.exception('Exception fetching bundle')
                 raise InternalError('Could not fetch bundle')
 
-            response.headers['Content-Type'] = 'application/octet-stream'
+            response.headers['Content-Type'] = 'text/plain'
             response.headers['Content-Length'] = len(bundle_data)
             response.body = bundle_data
             self.log.info('/bundle: %r seconds' % (time.time() - z,))

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2008-02-27 02:36:16 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-08-23 12:18:18 +0000
@@ -70,9 +70,9 @@
                     else:
                         i = None
                     scan_list = revid_list[i:]
-                change_list = scan_list[:pagesize]
-                changes = list(h.get_changes(change_list))
-                h.add_changes(changes)
+                entry_list = scan_list[:pagesize]
+                entries = h.get_changes(entry_list)
+                h.add_changes(entries)
             except:
                 self.log.exception('Exception fetching changes')
                 raise InternalError('Could not fetch changes')
@@ -83,24 +83,25 @@
                 navigation.query = query
             util.fill_in_navigation(navigation)
 
+            entries = list(entries)
             # add parent & merge-point branch-nick info, in case it's useful
-            h.get_branch_nicks(changes)
+            h.get_branch_nicks(entries)
 
             # does every change on this page have the same committer?  if so,
             # tell the template to show committer info in the "details block"
             # instead of on each line.
             all_same_author = True
 
-            if changes:
-                author = changes[0].author
-                for e in changes[1:]:
+            if entries:
+                author = entries[0].author
+                for e in entries[1:]:
                     if e.author != author:
                         all_same_author = False
                         break
 
             vals = {
                 'branch': self._branch,
-                'changes': changes,
+                'changes': entries,
                 'util': util,
                 'history': h,
                 'revid': revid,

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-02-27 02:40:57 +0000
+++ loggerhead/history.py	2007-09-10 13:41:13 +0000
@@ -60,19 +60,6 @@
 with_branch_lock = util.with_lock('_lock', 'branch')
 
 
-@decorator
-def with_bzrlib_read_lock(unbound):
-    def bzrlib_read_locked(self, *args, **kw):
-        #self.log.debug('-> %r bzr lock', id(threading.currentThread()))
-        self._branch.repository.lock_read()
-        try:
-            return unbound(self, *args, **kw)
-        finally:
-            self._branch.repository.unlock()
-            #self.log.debug('<- %r bzr lock', id(threading.currentThread()))
-    return bzrlib_read_locked
-
-
 # bzrlib's UIFactory is not thread-safe
 uihack = threading.local()
 
@@ -210,7 +197,10 @@
         self = cls()
         self._branch = branch
         self._last_revid = self._branch.last_revision()
-        self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
+        if self._last_revid is not None:
+            self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
+        else:
+            self._revision_graph = {}
 
         if name is None:
             name = self._branch.nick
@@ -220,20 +210,17 @@
         self._full_history = []
         self._revision_info = {}
         self._revno_revid = {}
-        if bzrlib.revision.is_null(self._last_revid):
-            self._merge_sort = []
-        else:
-            self._merge_sort = bzrlib.tsort.merge_sort(
-                self._revision_graph, self._last_revid, generate_revno=True)
+        self._merge_sort = bzrlib.tsort.merge_sort(self._revision_graph, self._last_revid, generate_revno=True)
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
             self._revno_revid[revno_str] = revid
             self._revision_info[revid] = (seq, revid, merge_depth, revno_str, end_of_merge)
+
         # cache merge info
         self._where_merged = {}
         for revid in self._revision_graph.keys():
-            if self._revision_info[revid][2] == 0:
+            if not revid in self._full_history:
                 continue
             for parent in self._revision_graph[revid]:
                 self._where_merged.setdefault(parent, set()).add(revid)
@@ -244,21 +231,13 @@
     @classmethod
     def from_folder(cls, path, name=None):
         b = bzrlib.branch.Branch.open(path)
-        b.lock_read()
-        try:
-            return cls.from_branch(b, name)
-        finally:
-            b.unlock()
+        return cls.from_branch(b, name)
 
     @with_branch_lock
     def out_of_date(self):
         # the branch may have been upgraded on disk, in which case we're stale.
-        newly_opened = bzrlib.branch.Branch.open(self._branch.base)
         if self._branch.__class__ is not \
-               newly_opened.__class__:
-            return True
-        if self._branch.repository.__class__ is not \
-               newly_opened.repository.__class__:
+               bzrlib.branch.Branch.open(self._branch.base).__class__:
             return True
         return self._branch.last_revision() != self._last_revid
 
@@ -271,10 +250,6 @@
     def use_search_index(self, index):
         self._index = index
 
-    @property
-    def has_revisions(self):
-        return not bzrlib.revision.is_null(self.last_revid)
-
     @with_branch_lock
     def detach(self):
         # called when a new history object needs to be created, because the
@@ -473,18 +448,16 @@
         use the URL parameters (revid, start_revid, file_id, and query) to
         determine the revision list we're viewing (start_revid, file_id, query)
         and where we are in it (revid).
-        
-            - if a query is given, we're viewing query results.
-            - if a file_id is given, we're viewing revisions for a specific
-              file.
-            - if a start_revid is given, we're viewing the branch from a
-              specific revision up the tree.
-
-        these may be combined to view revisions for a specific file, from
-        a specific revision, with a specific search query.
-            
-        returns a new (revid, start_revid, revid_list) where:
-        
+
+        if a query is given, we're viewing query results.
+        if a file_id is given, we're viewing revisions for a specific file.
+        if a start_revid is given, we're viewing the branch from a
+            specific revision up the tree.
+        (these may be combined to view revisions for a specific file, from
+            a specific revision, with a specific search query.)
+
+        returns a new (revid, start_revid, revid_list, scan_list) where:
+
             - revid: current position within the view
             - start_revid: starting revision of this view
             - revid_list: list of revision ids for this view
@@ -628,12 +601,6 @@
         for change in changes:
             merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(change.revid))
             change.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
-            if len(change.parents) > 0:
-                if isinstance(change.parents[0], util.Container):
-                    # old cache stored a potentially-bogus revno
-                    change.parents = [util.Container(revid=p.revid, revno=self.get_revno(p.revid)) for p in change.parents]
-                else:
-                    change.parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in change.parents]
             change.revno = self.get_revno(change.revid)
 
         parity = 0
@@ -643,62 +610,46 @@
 
         return changes
 
-    # alright, let's profile this sucka. (FIXME remove this eventually...)
-    def _get_changes_profiled(self, revid_list):
+    # alright, let's profile this sucka.
+    def _get_changes_profiled(self, revid_list, get_diffs=False):
         from loggerhead.lsprof import profile
         import cPickle
-        ret, stats = profile(self.get_changes_uncached, revid_list)
+        ret, stats = profile(self.get_changes_uncached, revid_list, get_diffs)
         stats.sort()
         stats.freeze()
         cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
         self.log.info('lsprof complete!')
         return ret
 
-    @with_branch_lock
-    @with_bzrlib_read_lock
-    def get_changes_uncached(self, revid_list):
-        revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
-                            revid_list)
-        repo = self._branch.repository
-        rev_list = repo.get_revisions(
-            repo.get_graph().get_parent_map(revid_list))
-
-        return [self._change_from_revision(rev) for rev in rev_list]
-
-    def _get_deltas_for_revisions_with_trees(self, revisions):
-        """Produce a list of revision deltas.
-        
+    def _get_deltas_for_revisions_with_trees(self, entries):
+        """Produce a generator of revision deltas.
+
         Note that the input is a sequence of REVISIONS, not revision_ids.
         Trees will be held in memory until the generator exits.
         Each delta is relative to the revision's lefthand predecessor.
-        (This is copied from bzrlib.)
         """
         required_trees = set()
-        for revision in revisions:
-            required_trees.add(revision.revid)
-            required_trees.update([p.revid for p in revision.parents[:1]])
+        for entry in entries:
+            required_trees.add(entry.revid)
+            required_trees.update([p.revid for p in entry.parents[:1]])
         trees = dict((t.get_revision_id(), t) for
                      t in self._branch.repository.revision_trees(required_trees))
         ret = []
         self._branch.repository.lock_read()
         try:
-            for revision in revisions:
-                if not revision.parents:
+            for entry in entries:
+                if not entry.parents:
                     old_tree = self._branch.repository.revision_tree(
                         bzrlib.revision.NULL_REVISION)
                 else:
-                    old_tree = trees[revision.parents[0].revid]
-                tree = trees[revision.revid]
+                    old_tree = trees[entry.parents[0].revid]
+                tree = trees[entry.revid]
                 ret.append(tree.changes_from(old_tree))
             return ret
         finally:
             self._branch.repository.unlock()
 
-    def _change_from_revision(self, revision):
-        """
-        Given a bzrlib Revision, return a processed "change" for use in
-        templates.
-        """
+    def entry_from_revision(self, revision):
         commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
 
         parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in revision.parent_ids]
@@ -713,10 +664,31 @@
             'short_comment': short_message,
             'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
-            'parents': revision.parent_ids,
+            'parents': parents,
         }
         return util.Container(entry)
 
+    @with_branch_lock
+    def get_changes_uncached(self, revid_list):
+        # Because we may loop and call get_revisions multiple times (to throw
+        # out dud revids), we grab a read lock.
+        self._branch.lock_read()
+        try:
+            while True:
+                try:
+                    rev_list = self._branch.repository.get_revisions(revid_list)
+                except (KeyError, bzrlib.errors.NoSuchRevision), e:
+                    # this sometimes happens with arch-converted branches.
+                    # i don't know why. :(
+                    self.log.debug('No such revision (skipping): %s', e)
+                    revid_list.remove(e.revision)
+                else:
+                    break
+
+            return [self.entry_from_revision(rev) for rev in rev_list]
+        finally:
+            self._branch.unlock()
+
     def get_file_changes_uncached(self, entries):
         delta_list = self._get_deltas_for_revisions_with_trees(entries)
 
@@ -737,11 +709,11 @@
 
     @with_branch_lock
     def get_change_with_diff(self, revid, compare_revid=None):
-        change = self.get_changes([revid])[0]
+        entry = self.get_changes([revid])[0]
 
         if compare_revid is None:
-            if change.parents:
-                compare_revid = change.parents[0].revid
+            if entry.parents:
+                compare_revid = entry.parents[0].revid
             else:
                 compare_revid = 'null:'
 
@@ -749,10 +721,11 @@
         rev_tree2 = self._branch.repository.revision_tree(revid)
         delta = rev_tree2.changes_from(rev_tree1)
 
-        change.changes = self.parse_delta(delta)
-        change.changes.modified = self._parse_diffs(rev_tree1, rev_tree2, delta)
-
-        return change
+        entry.changes = self.parse_delta(delta)
+
+        entry.changes.modified = self._parse_diffs(rev_tree1, rev_tree2, delta)
+
+        return entry
 
     @with_branch_lock
     def get_file(self, file_id, revid):

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2007-09-04 01:47:51 +0000
+++ loggerhead/static/css/style.css	2007-07-04 12:08:51 +0000
@@ -216,7 +216,7 @@
 }
 
 .log-entries .revision-header {
-    font-size: 1.0em;
+    font-size: normal;
 }
 
 .log-entries .revision-header td {
@@ -315,6 +315,10 @@
     padding-bottom: 2px;
 }
 
+.revision-info table td.date {
+    font-family: monospace;
+}
+
 .revision-info table td.description {
     font-family: monospace;
 }
@@ -499,8 +503,6 @@
     font-family: monospace;
     font-size: smaller;
     width: 5em;
-    line-height: 1em;
-    vertical-align: bottom;
 }
 
 .inventory td.revision {
@@ -511,7 +513,7 @@
 
 .inventory td.date {
     padding-right: 1em;
-    width: 11em;
+    width: 10em;
 }
 
 .inventory td.changes-link {

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2007-09-04 17:06:03 +0000
+++ loggerhead/templates/annotate.kid	2007-06-21 16:39:33 +0000
@@ -31,7 +31,7 @@
             <td class="lineno ${line.status}"><a name="L${line.lineno}"> ${line.lineno} </a></td>
             <td class="revno ${line.status}">
                 <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${util.format_date(line.change.date)} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
+                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
             <td class="text ${line.status}"> ${line.text} </td>
         </tr>

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2008-02-27 01:55:39 +0000
+++ loggerhead/templates/browse.kid	2007-06-08 11:52:33 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${view.get_history().has_revisions and util.ago(view.last_updated()) or "(no revisions)"} </td>
+            <td class="last-update"> ${view.get_history().last_revid and util.ago(view.last_updated()) or "(no revisions)"} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2007-09-04 17:21:59 +0000
+++ loggerhead/templates/changelog.kid	2007-06-26 05:34:28 +0000
@@ -14,22 +14,7 @@
         <a href="${branch.url([ '/annotate', revid ], **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
     </span>
     
-    <span py:def="file_diff_link(revid, filename)">
-        <a href="javascript:diff_url('${branch.context_url([ '/revision', revid ]) + '#' + filename}')"
-           title="View diff for ${filename}">${filename}</a>
-    </span>
-    
     ${use_collapse_buttons()}
-
-    <script type="text/javascript"> <!--
-    function diff_url(url) {
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            this.location.href = url + "-u";
-        } else {
-            this.location.href = url + "-s";
-        }
-    }
-    // --> </script>
 </head>
 
 <body onload="javascript:sortCollapseElements();">
@@ -77,7 +62,7 @@
             <span py:strip="True" py:if="not all_same_author">
                 <td class="author"> ${util.trunc(util.hide_email(entry.author), 20)} </td>
             </span>
-            <td class="date"> ${util.format_date(entry.date)} &nbsp; (${util.ago(entry.date)}) </td>
+            <td class="date"> ${entry.date.strftime('%Y-%m-%d, %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
             <td class="inventory-link"> 
                 <a href="${branch.url([ '/files', entry.revid ])}"
                     title="Files at revision ${entry.revno}"> files</a>
@@ -98,9 +83,9 @@
                 <tr py:if="len(entry.parents) > 1">
                     <th class="parents"> merged from: </th>
                     <td class="parents">
-                        <span py:for="parent in entry.parents[1:]">
-                            ${loglink(parent.revid, parent.revno + util.if_present(' (%s)', parent.branch_nick))} <br />
-                        </span>
+                        <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
+                            ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
+                        </span></span>
                     </td>
                 </tr>
                 <span py:strip="True" py:if="all_same_author">
@@ -130,7 +115,8 @@
                 <tr py:if="entry.changes.modified">
                     <th class="files"> files modified: </th>
                     <td class="files"> <span py:for="item in entry.changes.modified">
-                        <span class="filename">${file_diff_link(entry.revid, item.filename)}</span>
+                        <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
+                        <a href="${branch.url([ '/revision', entry.revid ], **util.get_context()) + '#' + item.filename}" class="jump">&#8594; diff</a>
                         <br />
                     </span> </td>
                 </tr>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2007-09-04 17:06:03 +0000
+++ loggerhead/templates/inventory.kid	2007-06-25 06:44:52 +0000
@@ -12,9 +12,9 @@
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : files for revision ${change.revno}
 	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.context_url('/revision', clear=1, start_revid=revid)}">
+	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}">
 	        view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.context_url('/changes', clear=1, start_revid=revid)}">
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid))}">
 	        view branch changes </a> </div>
 	</div>
 </h1>
@@ -28,7 +28,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.format_date(change.date)} </td>
+            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -62,34 +62,35 @@
 <table class="inventory" width="100%">
     <tr class="header">
         <th class="permissions"> Permissions </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='filename')}">Filename</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='filename'))}">Filename</a> </th>
         <th> Latest Rev </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='date')}">Last Changed</a> </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='size')}">Size</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='date'))}">Last Changed</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='size'))}">Size</a> </th>
         <th>  </th>
         <th>  </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
         <td class="permissions">drwxr-xr-x</td>
-        <td class="filename directory"><a href="${branch.context_url([ '/files', revid ], file_id=updir_file_id)}"> (up) </a></td>
+        <td class="filename directory"><a href="${branch.url([ '/files', revid ],
+            **util.get_context(file_id=updir_file_id))}"> (up) </a></td>
         <td> </td> <td> </td> <td> </td> <td> </td>
     </tr>
 
     <tr py:for="file in filelist" class="parity${file.parity}">
         <td class="permissions"> ${util.fake_permissions(file.kind, file.executable)} </td>
         <td class="filename ${file.kind}">
-            <a py:if="file.kind=='directory'" href="${branch.context_url([ '/files', revid ],
-                file_id=file.file_id)}">${file.filename}/</a>
+            <a py:if="file.kind=='directory'" href="${branch.url([ '/files', revid ],
+                **util.get_context(file_id=file.file_id))}">${file.filename}/</a>
             <span py:if="file.kind=='symlink'">${file.filename}@</span>
-            <a py:if="file.kind=='file'" href="${branch.context_url([ '/annotate', revid ],
-                file_id=file.file_id)}" title="Annotate ${file.filename}">${file.filename}</a>
+            <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ],
+                **util.get_context(file_id=file.file_id))}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
         <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
-        <td class="date"> ${util.format_date(file.change.date)} </td>
+        <td class="date"> ${file.change.date.strftime('%Y-%m-%d, %H:%M')} </td>
         <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
         <td class="changes-link"> 
-            <a href="${branch.context_url('/changes', start_revid=file.revid, file_id=file.file_id)}"
+            <a href="${branch.url('/changes', **util.get_context(start_revid=file.revid, file_id=file.file_id))}"
                title="Changes affecting ${file.filename} up to revision ${file.change.revno}"> changes </a>
         </td>
         <td class="download-link">

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2007-09-02 22:54:43 +0000
+++ loggerhead/templates/master.kid	2007-01-24 19:17:40 +0000
@@ -19,8 +19,8 @@
               file_id=getattr(navigation, 'file_id', None))}"><table><tr>
             <td><span class="buttons">
                 <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                <a href="${branch.context_url('/changes', clear=1)}"> changes </a>
-                <a href="${branch.context_url('/files', clear=1)}"> files </a>
+                <a href="${branch.url('/changes', **util.get_context(clear=1))}"> changes </a>
+                <a href="${branch.url('/files', **util.get_context(clear=1))}"> files </a>
                 <span class="search"> search: <input type="text" name="q" /> </span>
             </span></td>
             <td align="right" py:if="hasattr(navigation, 'revid_list')">
@@ -34,7 +34,8 @@
                     </span>
                 	<span py:if="not navigation.prev_page_revid"> &#171; </span>
                     revision ${history.get_revno(revid)}
-                    (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
+                    (<span py:if="navigation.pagesize > 1">page </span>
+                    ${navigation.page_position} / ${navigation.page_count})
                 	<span py:if="navigation.next_page_revid">
                     <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
                     </span>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2007-09-04 17:06:03 +0000
+++ loggerhead/templates/revision.kid	2007-06-26 06:28:36 +0000
@@ -17,33 +17,24 @@
     <span py:replace="use_collapse_buttons()"></span>
     
     <script type="text/javascript"> <!--
-    function show_sbs(path) {
+    function show_sbs() {
         collapseDisplay('style', 'sbs', 'table');
         collapseDisplay('style', 'unified', 'none');
-        document.cookie='diff=sbs; path=' + path; 
+        document.cookie='diff=sbs';
     }
-    function show_unified(path) {
+    function show_unified() {
         collapseDisplay('style', 'unified', 'table');
         collapseDisplay('style', 'sbs', 'none');
-        document.cookie='diff=unified; path=' + path; 
+        document.cookie='diff=unified'; 
     }
-    function load(path) {
+    function load() {
         sortCollapseElements();
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            show_unified(path);
-        }
-        if (document.cookie.indexOf('stop=1') >= 0) {
-            return;
-        }
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            window.location.hash = window.location.hash;
-            document.cookie='stop=1; max-age=5; path=' + window.location.pathname;
-        } 
+        if (document.cookie.indexOf('diff=unified') >= 0) { show_unified(); }
     }
     // --> </script>
 </head>
 
-<body onload="javascript:load('${branch.url('/')}')">
+<body onload="javascript:load()">
 
 ${navbar()}
 
@@ -51,27 +42,32 @@
     <span py:if="compare_revid is not None"> (compared to revision ${history.get_revno(compare_revid)}) </span>
     
     <div class="links">
-        <div> <b>&#8594;</b> <a href="${branch.context_url([ '/files', revid ])}">
-            browse files at revision ${change.revno} </a> </div>
-        <div> <b>&#8594;</b> <a href="${branch.context_url('/changes', start_revid=revid)}">
-            view history from revision ${change.revno} </a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context())}">
+            browse files</a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(start_revid=revid))}">
+            view branch changes</a> </div>
+        <span py:if="compare_revid is None" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, 'bundle.txt' ])}">
+                view/download patch</a> </div>
+        </span>
         <span py:if="compare_revid is not None" py:strip="True">
             <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, compare_revid, 'bundle.txt' ])}">
-                download bundle from ${history.get_revno(compare_revid)} to ${change.revno} </a> </div>
+                view/download patch</a> </div>
         </span>
-        <span py:if="(remember is not None) and (compare_revid is None) and (revid != remember)" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], compare_revid=remember)}">
+        <span py:if="(remember is not None) and (compare_revid is None)" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(compare_revid=remember))}">
                 compare with revision ${history.get_revno(remember)} </a></div>
         </span>
         <span py:if="remember != revid" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], remember=revid, compare_revid=None)}">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=revid, compare_revid=None))}">
                 compare with another revision </a></div>
         </span>
         <span py:if="compare_revid is not None" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', compare_revid ], remember=revid, compare_revid=revid)}">
-                reverse the comparison (${change.revno} to ${history.get_revno(compare_revid)})</a></div>
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], remember=None, compare_revid=None)}">
-                stop comparing with revision ${history.get_revno(compare_revid)} </a></div>
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=None, compare_revid=None))}">
+                stop comparing to revision ${history.get_revno(compare_revid)} </a></div>
         </span>
     </div>
 </h1>
@@ -84,7 +80,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.format_date(change.date)} </td>
+            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -146,9 +142,9 @@
     <td> ${collapse_all_button('file', 'table-row')} </td>
 
     <td class="spacey">
-        <a href="javascript:show_sbs('${branch.url('/')}')" class="hide-all collapse-style-sbs-show" title="collapse">
+        <a href="javascript:show_sbs()" class="hide-all collapse-style-sbs-show" title="collapse">
             <img src="${tg.url('/static/images/nav-small-out.gif')}" width="22" height="10" class="collapse-triangle" />show side by side</a>
-        <a href="javascript:show_unified('${branch.url('/')}')" class="hide-all collapse-style-unified-show" title="expand">
+        <a href="javascript:show_unified()" class="hide-all collapse-style-unified-show" title="expand">
             <img src="${tg.url('/static/images/nav-small-in.gif')}" width="22" height="10" class="collapse-triangle" />show unified diff</a>
     </td>
     

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2008-02-27 02:41:36 +0000
+++ loggerhead/tests/test_simple.py	2007-09-07 18:46:20 +0000
@@ -84,7 +84,7 @@
     def test_index(self):
         testutil.create_request('/')
         link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0].lower()
+        assert link in cherrypy.response.body[0]
 
     def test_changes(self):
         testutil.create_request('/project/branch/changes')
@@ -128,7 +128,7 @@
     def test_index(self):
         testutil.create_request('/')
         link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0].lower()
+        assert link in cherrypy.response.body[0]
 
     def test_changes(self):
         testutil.create_request('/project/branch/changes')

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2007-09-04 17:06:03 +0000
+++ loggerhead/util.py	2007-06-25 06:44:52 +0000
@@ -78,25 +78,6 @@
     return year
 
 
-_g_format = '%Y-%m-%d @ %H:%M'
-
-def format_date(date):
-    if _g_format == 'fancy':
-        return fancy_format_date(date)
-    return date.strftime(_g_format)
-
-def fancy_format_date(date):
-    delta = datetime.datetime.now() - date
-    if delta.days > 300:
-        return date.strftime('%d %b %Y')
-    else:
-        return date.strftime('%d %b %H:%M')
-
-def set_date_format(format):
-    global _g_format
-    _g_format = format
-
-
 class Container (object):
     """
     Convert a dict into an object with attributes.

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2007-09-04 17:06:03 +0000
+++ start-loggerhead.py	2007-06-19 00:09:43 +0000
@@ -12,7 +12,7 @@
 import cherrypy
 cherrypy.lowercase_api = True
 
-from loggerhead import daemon, release, util
+from loggerhead import daemon, release
 
 
 def make_handler(config, filename):
@@ -111,10 +111,10 @@
     Root = Root(config)
     
     # re-index every 6 hours
+    
     index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
     turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
-
-    util.set_date_format(config.get('date_format', 'fancy'))
+    
     try:
         turbogears.start_server(Root)
     finally:

